% Funzione che converte i dati del fessurimetro 2D

function [Dati2DCrack,DatiNTCCrack2D,Err2DCrackLink] = conv_grezzi2DCrL(...
    Crack2D,NTCCrack2D,DCal2DCrLTot,Nodo2DCrackLink,Err2DCrackLink,CrL2D_NTC,...
    r2DCrL,NuovoZero2DCrL,IDcentralina,DTcatena,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'conv_grezzi2DCrL function started';
fprintf(fileID,fmt,text);

[rA,cA] = size(Crack2D);
Dati2DCrack = zeros(rA,cA);
DatiNTCCrack2D = zeros(rA,cA/2);
scrivo = 0;
cx_rif = zeros(r2DCrL,1);
cy_rif = zeros(r2DCrL,1);
RIF = zeros(r2DCrL,2);
ii = 1;
for e = 1:r2DCrL % numero di 2D Crack Link
    if strcmp(Nodo2DCrackLink(e,3),'4-20 mA')
        %% Conversione da mA a mm
        % Spacchetto i parametri di calibrazione
        ax = DCal2DCrLTot(e,1);
        bx = DCal2DCrLTot(e,2);
        cx = DCal2DCrLTot(e,3);
        ay = DCal2DCrLTot(e,4);
        by = DCal2DCrLTot(e,5);
        cy = DCal2DCrLTot(e,6);
        Dati2DCrack(:,ii) = ax*(Crack2D(:,ii).^2)+bx*Crack2D(:,ii)+cx; % conversione X
        Dati2DCrack(:,ii+1) = ay*(Crack2D(:,ii+1).^2)+by*Crack2D(:,ii+1)+cy; % conversione Y
        ii = ii+2;
    elseif strcmp(Nodo2DCrackLink(e,3),'mV/V')
        %% Conversione da mV/V a mm
        % Spacchetto i parametri di calibrazione
        ax = DCal2DCrLTot(e,1);
        bx = DCal2DCrLTot(e,2);
        ay = DCal2DCrLTot(e,3);
        by = DCal2DCrLTot(e,4);
        Dati2DCrack(:,ii) = ax*Crack2D(:,ii)+bx; % conversione x
        Dati2DCrack(:,ii+1) = ay*Crack2D(:,ii+1)+by; % conversione y
        ii = ii+2;
    elseif strcmp(Nodo2DCrackLink(e,3),'Hz')
        %% Conversione da mA a mm
        % Spacchetto i parametri di calibrazione
        ax = DCal2DCrLTot(e,1);
        bx = DCal2DCrLTot(e,2);
        cx = DCal2DCrLTot(e,3);
        ay = DCal2DCrLTot(e,4);
        by = DCal2DCrLTot(e,5);
        cy = DCal2DCrLTot(e,6);
        digitX = (Crack2D(:,ii).^2)/1000;
        digitY = (Crack2D(:,ii+1).^2)/1000;
        if cx == 0 && cy == 0 % Sensori Geosense
            NomeFile = ['' IDcentralina '-' DTcatena '-Rif2DCrL.csv'];
            if NuovoZero2DCrL == 0 % Prima elaborazione
                scrivo = 1;
                cx = -ax*digitX(1,e).^2-bx*digitX(1,e);
                cx_rif(e,1) = cx; 
                cy = -ay*digitY(1,e).^2-by*digitY(1,e);
                cy_rif(e,1) = cy; 
                RIF(e,1:2) = [cx_rif(e,1) cy_rif(e,1)];
            else
                RIF = csvread(NomeFile);
                cx = RIF(e,1);
                cy = RIF(e,2);
            end
        end
        Dati2DCrack(:,ii) = ax*(digitX.^2)+bx*digitX+cx; % conversione
        Dati2DCrack(:,ii+1) = ay*(digitY.^2)+by*digitY+cy; % conversione
        ii = ii+2;
    end
    A = 1.4051*10^(-3);
    B = 2.369*10^(-4);
    C = 1.019*10^(-7);
    if CrL2D_NTC(e,1)==1 % è presente il termometro
        R = NTCCrack2D(:,e);
        [rN,~] = size(R);
        for n = 1:rN
            if R(n) <= 0
                if n > 1
                    R(n) = R(n-1);
                else
                    R(n) = 5000;
                end
                if Err2DCrackLink(n,ii) == 0
                    Err2DCrackLink(n,ii) = 0.5;
                end
            end
        end
        L = reallog(R);
        DatiNTCCrack2D(:,e) = (1./(A + B*L + C*(L.^3))) -273.2; % conversione in gradi centigradi
    end
end
if scrivo == 1
    csvwrite(NomeFile,RIF);
end

text = 'Calibrations of 2D Crack Link defined correctly. conv_grezzi2DCrL function closed';
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
fclose(fileID);
end